/* 
  tiltmap.js

  Written by John Keogh of EyesBot, LLC for demo purposes and released 
  into the public domain.  No warrantee or guarantee of any type is 
  associated with this code.  Use at you own risk.  
  
  None of this code handles errors well, as it is demo code for teaching
  purposes.
*/

//this retrieves a list of runs from a REST style web service at /run
//on the same server as this code was downloaded from and lists those
//runs in the runslistspan span
function listRuns(){
	var runsSpan = document.getElementById("runslistspan");
	var runsData = getRuns();

	var runNames = "";
	for (var i = 0; i < runsData.runnames.length; i++) {
	    var runName = runsData.runnames[i];
	    runNames+="<span onclick=\"setupMap('"+runName.run_name+"');\">"+runName.run_name+"</span><BR>\r\n";
	}
	
	runsSpan.innerHTML = runNames;
}

//this retrieves a list of runs from a REST style web service at /run
//on the same server as this code was downloaded from and lists those
//runs in the runslistspan span
function setupMap(runName){
	var mapSpan = document.getElementById("tiltmapspan");
	
	var mapData = getRunData(runName);

	var mapSpans = "";
	for (var i = 0; i < mapData.runs.length; i++) {
	    var runPoint = mapData.runs[i];
	    
	    var rgbString = "#";
	    rgbString += (parseInt((parseFloat(runPoint.x_tilt)*125.0)+125.0)).toString(16);
	    rgbString += (parseInt((parseFloat(runPoint.y_tilt)*125.0)+125.0)).toString(16);
	    rgbString += (parseInt((parseFloat(runPoint.z_tilt)*125.0)+125.0)).toString(16);
	    
	    var xLocation=parseInt(runPoint.x_location)*2;
	    var yLocation=parseInt(runPoint.y_location)*2;
	    
	    mapSpans+="<span style=\"width:20px;height:20px;position:absolute;left:"+xLocation+"px;top:"+yLocation+"px;background-color:"+rgbString+";\"></span>";
	}	
	
	mapSpan.innerHTML = mapSpans;
}


function getRuns(){
    var xmlHttp;
    
    if (window.XMLHttpRequest){
        xmlHttp = new XMLHttpRequest();
    }else{
        if (window.ActiveXObject){
            xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
        }else{
            xmlHttp = null;
        }
    }
  
    xmlHttp.open("GET", "/runs", false);
    xmlHttp.send(null);
    
    return JSON.parse(xmlHttp.responseText);
}

//retrieves runs form a 
function getRunData(runName){
    var xmlHttp;
    
    if (window.XMLHttpRequest){
        xmlHttp = new XMLHttpRequest();
    }else{
        if (window.ActiveXObject){
            xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
        }else{
            xmlHttp = null;
        }
    }

    xmlHttp.open("GET", "/run/runname?id="+runName, false);
    xmlHttp.send(null);

    return JSON.parse(xmlHttp.responseText);
}
